package org.jax.helloworld;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.core.runtime.IConfigurationElement;
import org.eclipse.core.runtime.IExtension;
import org.eclipse.core.runtime.IExtensionPoint;
import org.eclipse.core.runtime.IExtensionRegistry;
import org.eclipse.core.runtime.Platform;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.part.ViewPart;
import org.jax.helloworld.api.IMyMessage;

public class MyView extends ViewPart {

	public MyView() {
		super();
	}

	public void createPartControl(Composite parent) {
		Text mytext = new Text(parent, SWT.LEFT | SWT.MULTI);
		
		String[] messages = getMessages();
		for (int i = 0; i < messages.length; i++) {
			mytext.append(messages[i] + "\n");
		}
	}

	private String[] getMessages() {
		List result = new ArrayList();
		
		IExtensionRegistry registry = Platform.getExtensionRegistry();
		IExtensionPoint extensionPoint = registry.getExtensionPoint("org.jax.helloworld.mypoint");
		IExtension[] extensions = extensionPoint.getExtensions();
		
		for (int i = 0; i < extensions.length; i++) {
			IConfigurationElement[] configurationElements = extensions[i].getConfigurationElements();
			for (int j = 0; j < configurationElements.length; j++) {
				if (configurationElements[j].getName().equals("message")) {
					try {
						IMyMessage messageProvider = (IMyMessage) configurationElements[j].createExecutableExtension("class");
						result.add(messageProvider.getMessage());
					} catch (Exception e) {
						e.printStackTrace();
					}
				}
			}
		}
		
		return (String[]) result.toArray(new String[result.size()]);
	}

	public void setFocus() {
	}

}
